#include "addmachinedialog.h"
#include "ui_addmachinedialog.h"

AddMachineDialog::AddMachineDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::AddMachineDialog)
{
    ui->setupUi(this);
    setWindowModality(Qt::ApplicationModal);
    setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowCloseButtonHint);

    QRegExp ipExp("(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)");
    ui->lineEdit_ip->setValidator(new QRegExpValidator(ipExp, ui->lineEdit_ip));
}

AddMachineDialog::~AddMachineDialog()
{
    delete ui;
}

void AddMachineDialog::on_pushButton_ok_clicked()
{
    m_mcIp = ui->lineEdit_ip->text();
    m_mcName = ui->lineEdit_name->text();

    bool bl = true;
    if(m_mcIp.isEmpty())
    {
        bl = false;
    }
    QStringList list = m_mcIp.split('.');
    if(list.size() != 4)
    {
        bl = false;
    }
    for(const auto& num : list)
    {
        bool ok = false;
        int temp = num.toInt(&ok);
        if(!ok || temp < 0 || temp > 255)
        {
            bl = false;
        }
    }

    if(bl == false)
    {
        QMessageBox::warning(this,
                                             tr("Prompt"),
                                             tr("Please enter the correct IP!"),//请输入正确的IP！
                                             QMessageBox::Ok);
        return;
    }

    if(m_mcName.length() <= 0)
    {
        QMessageBox::warning(this,
                                             tr("Prompt"),
                                             tr("Please enter the correct machine name!"),//请输入正确的机器名称！
                                             QMessageBox::Ok);
        return;
    }

    done(1);
}

void AddMachineDialog::on_pushButton_cancel_clicked()
{
    done(0);
}
