#ifndef MYGRAPHICSVIEW_H
#define MYGRAPHICSVIEW_H

#include <QObject>
#include <QGraphicsView>
#include <QMouseEvent>
#include <QWheelEvent>
#include <QScrollBar>
#include "datafile/view/mygraphicsscene.h"

class MyGraphicsView : public QGraphicsView
{
    Q_OBJECT
public:
    MyGraphicsView();
    ~MyGraphicsView();

private:
    MyGraphicsScene *m_scene;
    QSize m_viewSize;

    //鼠标起始点和结束点
    QPoint m_startPoint;
    QPoint m_endPoint;
    bool m_leftBtnPressed = false;
    bool m_rightBtnPressed = false;

protected:
    void resizeEvent(QResizeEvent *event);//窗口大小发生变化的时候，该函数触发
    void mouseDoubleClickEvent(QMouseEvent *event);
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void wheelEvent(QWheelEvent *event);

public:
    CreatPictureStr getPictureByDat(Marker marker,int paperWidth,int butSpace,int rightSpace,int penWidth = 1);
    CreatPictureStr getPictureByBmp(QPixmap pixmap,int paperWidth,int butSpace,int rightSpace,int penWidth = 1);
    void cleanView();
    void swithViewByPic(QPicture pic);
    void reflushBlockView(QPoint p);

signals:
    void siMouseMove(QPointF point);

public slots:
};

#endif // MYGRAPHICSVIEW_H
