#ifndef ZIPWRITER_H
#define ZIPWRITER_H

#include <QtGlobal>
#include <QString>
#include <QIODevice>

#include "zip.h"

class ZipWriter
{
public:
    explicit ZipWriter(const QString &filePath);
    explicit ZipWriter(QIODevice *device);
    ~ZipWriter();

    void addFile(const QString &filePath, QIODevice *device);
    void addFile(const QString &filePath, const QByteArray &data);
    bool error() const;
    void close();

private:
    HZIP m_writer;
    ZRESULT m_result;
};

#endif // ZIPWRITER_H
