#ifndef PRINTINFODIALOG_H
#define PRINTINFODIALOG_H

#include <QDialog>
#include <QStringListModel>
#include "main.h"
#include "datafile/view/mygraphicsview.h"
#include "machine/machine.h"

namespace Ui {
class PrintInfoDialog;
}

class PrintInfoDialog : public QDialog
{
    Q_OBJECT

public:
    explicit PrintInfoDialog(QWidget *parent = 0);
    ~PrintInfoDialog();
    void refreshLanguage();

private slots:
    void on_listView_blockList_clicked(const QModelIndex &index);
    void on_pushButton_back_clicked();

private:
    Ui::PrintInfoDialog *ui;
    QStringListModel *m_listViewModel;
    int m_curBlockRow;//数据块
    MyGraphicsView *m_preView;
    McFilesInfo m_curFilesInfo;//当前文件信息

private:
    void reflushFileInfo();

public:
    void setFilesInfo(McFilesInfo filesInfo);
};

#endif // PRINTINFODIALOG_H
