#include "printnumbersetdialog.h"
#include "ui_printnumbersetdialog.h"

PrintNumberSetDialog::PrintNumberSetDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::PrintNumberSetDialog)
{
    ui->setupUi(this);
    setWindowModality(Qt::ApplicationModal);
    setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowCloseButtonHint);
    m_printNumber = 0;
    //整数
    QIntValidator *Validator = new QIntValidator(this);
    ui->lineEdit_number->setValidator(Validator);
}

PrintNumberSetDialog::~PrintNumberSetDialog()
{
    delete ui;
}

int PrintNumberSetDialog::exec(QString title,QString text)
{
    ui->lineEdit_number->setText(text);
    m_printNumber = text.toInt();
    this->setWindowTitle(title);
    return QDialog::exec();
}

void PrintNumberSetDialog::on_pushButton_ok_clicked()
{
    m_printNumber = ui->lineEdit_number->text().toInt();
    if(m_printNumber <= 0 || m_printNumber > 255)
    {
        QMessageBox::warning(this,
                                             tr("Prompt"),
                                             tr("Unreasonable value input!"),//数值输入不合理
                                             QMessageBox::Ok);
        return;
    }
    done(1);
}

void PrintNumberSetDialog::on_pushButton_cancel_clicked()
{
    done(0);
}
