#ifndef PRINTVIEWWINDOW_H
#define PRINTVIEWWINDOW_H

#include <QMainWindow>
#include <QMessageBox>
#include <QDir>
#include <QList>
#include "datafile/view/mygraphicsview.h"
#include "machine/machine.h"
#include "main.h"

namespace Ui {
class PrintViewWindow;
}

class PrintViewWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit PrintViewWindow(QWidget *parent = 0);
    ~PrintViewWindow();
    void refreshLanguage();

private:
    Ui::PrintViewWindow *ui;

    MyGraphicsView *m_view;
    int m_startPoint;
    int m_printNumber;
    QString m_filePath;
    int m_addNewFileFlag;
    int m_length;

public:
    void refreshShow(McFilesInfo &mcFilesInfo,int paperWidth,int butSpace,int rightSpace,int penWidth,int flag = 0);
    void setStartLineText(QString str);
    void setNumberLineText(QString str);
    inline int getStartPoint(){return m_startPoint;}
    inline int getPrintNumber(){return m_printNumber;}

signals:
    void siAddNewFile(int newFlag);

public slots:
    void slotShowPoint(QPointF point);

private slots:
    void on_pushButton_draw_clicked();
};

#endif // PRINTVIEWWINDOW_H
